/**
 * @author Administrator
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

package com.ibm.jps.umltoxml.transformationProvider;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.runtime.IStatus;

import com.ibm.jps.umltoxml.util.StatusUtility;
import com.ibm.xtools.transform.core.AbstractTransform;
import com.ibm.xtools.transform.core.AbstractTransformationProvider;
import com.ibm.xtools.transform.core.ITransformContext;
import com.ibm.xtools.transform.core.ITransformationDescriptor;


/**
 * TransformationProvider is registered in plugin.xml as a Transformation
 * Provider.
 *  
 */
/*
 * (non-Javadoc)
 * 
 * @see com.ibm.xtools.transform.core.AbstractTransformationProvider
 */
public class UMLToXMLTransformationProvider extends AbstractTransformationProvider {

    /*
     * (non-Javadoc)
     * 
     * @see com.ibm.xtools.transform.core.AbstractTransformationProvider#createTransformation(com.ibm.xtools.transform.core.ITransformationDescriptor)
     */
    public AbstractTransform createTransformation(
            ITransformationDescriptor descriptor) {
        if (descriptor.getId().equals("com.ibm.jps.umltoxml.transformation")) {
            UMLToXMLRootTransformation transform = new UMLToXMLRootTransformation(
                    descriptor);
            return transform;
        }
        return null;
    }

    /*
     * (non-Javadoc)
     * 
     * @see com.ibm.xtools.transform.core.AbstractTransformationProvider#validateContext(com.ibm.xtools.transform.core.ITransformationDescriptor,
     *      com.ibm.xtools.transform.core.ITransformContext)
     */
    public IStatus validateContext(ITransformationDescriptor descriptor,
            ITransformContext context) {
        AbstractTransform transform = context.getTransform();
        boolean isSourceOk = transform.canAccept(context);
        Object target = context.getTargetContainer();
        boolean isTargetOk = (target instanceof IProject) ? true : false;
        // TODO should check for JSF vs. Struts
        boolean arePropertiesOk = true;

        final String sourceErrMsg = "Source invalide"; //$NON-NLS-1$
        final String targetErrMsg = "Cible invalide"; //$NON-NLS-1$
        final String pluginId = "com.ibm.jps.umltoxml";

        return StatusUtility.createTransformContextValidationStatus(pluginId,
                isSourceOk, sourceErrMsg, isTargetOk, targetErrMsg,
                arePropertiesOk);
    }
}
